#include <stdio.h>
#include <stdlib.h>
#include "list.h"

void init(list_t *list)
{
    list->head = (node_t *)malloc(sizeof(node_t));
    list->head->next = NULL;
    list->cur = list->head;
    list->cnt = 0;
}

void destroy(list_t *list)
{
    node_t *temp;
    list->cur = list->head;
    while(list->cur->next != NULL)
    {
        temp = list->cur;
        list->cur = list->cur->next;
        free(temp);
    }
}

void insert(list_t *list, int data)
{
    node_t *new = (node_t *)malloc(sizeof(node_t));
    if(!new)
    {
        printf("memory allocation error");
        return;
    }
    new->data = data;
    new->next = list->head->next;
    list->head->next = new;
}

void print(list_t *list)
{
    list->cur = list->head;
    printf("list: ");
    while(list->cur->next != NULL)
    {
        list->cur = list->cur->next;
        printf("%d ", list->cur->data);
    }
    printf("\n"); 
}

void search(list_t *list, int data)
{
    list->cur = list->head;
    printf("\nsearching for %d: ", data);
    while(list->cur->next != NULL)
    {
        if(list->cur->data == data)
        {
             printf("[%d] found\n", list->cur->data);
             return;
        }
        else
        {
             list->cur = list->cur->next;
        }
    }
    printf("[%d] not found\n", data);
    printf("search completed\n");
}

void delete(list_t *list, int data)
{
    node_t *temp;
    list->cur = list->head;
    while(list->cur->next != NULL)
    {
        temp = list->cur->next;

        if(temp->data == data)
        {
            printf("[%d] found", temp->data);
            list->cur->next = temp->next;
            free(temp);
            return;
        }
        else
        {
            list->cur = list->cur->next;
        }
    }
    printf("[%d] not found", data);
}
